/*-
 *  Copyright 2020 Beuth Hochschule für Technik Berlin, Hochschule für Technik Stuttgart
 * 
 *  This file is part of CityDoctor2.
 *
 *  CityDoctor2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  CityDoctor2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with CityDoctor2.  If not, see <https://www.gnu.org/licenses/>.
 */
package de.hft.stuttgart.citydoctor2.math.graph;

import static org.junit.Assert.assertTrue;

import java.util.List;

import org.junit.Test;

import de.hft.stuttgart.citydoctor2.datastructure.Vertex;

/**
 * 
 * @author Matthias Betz
 *
 */
public class KDTreeTest {

	@Test
	public void testGetNodesInRange() {
		Vertex v1 = new Vertex(0, 0, 0);
		Vertex v2 = new Vertex(0, 0, 0.1);
		Vertex v3 = new Vertex(0.1, 0, 0);
		Vertex v4 = new Vertex(-0.201, 0, 0);
		
		KDTree tree = new KDTree();
		tree.add(v1);
		tree.add(v2);
		tree.add(v3);
		tree.add(v4);
		
		List<Vertex> nodesInRange = tree.getNodesInRange(new Vertex(0, 0, 0), 0.2);
		assertTrue(nodesInRange.contains(v1));
		assertTrue(nodesInRange.contains(v2));
		assertTrue(nodesInRange.contains(v3));
	}

}
